#!/usr/bin/env node
import { qwikSpeakExtract as p } from "./index.js";
import "fs/promises";
import "fs";
import "path";
/**
 * @license
 * Qwik Speak
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/robisim74/qwik-speak/blob/main/LICENSE
 */
function c(a) {
  const s = a.split("=");
  if (s.length === 2 && s[0].startsWith("--")) {
    const e = s[0].slice(2), i = /,/.test(s[1]) ? s[1].split(",") : s[1];
    return { key: e, value: i };
  }
  return { key: "error", value: `- wrong option: "${s[0]}"` };
}
const o = (a, s) => !!(s === a || s === "array" && Array.isArray(a) || s === "string" && typeof a == "string"), n = (a, s) => `- option "${a}": wrong value ${JSON.stringify(s)}`, l = (a) => `- missing option: "${a}"`, u = process.argv.slice(2), r = {}, t = [];
for (const a of u) {
  const { key: s, value: e } = c(a);
  switch (s) {
    case "basePath":
      o(e, "string") ? r.basePath = e : t.push(n(s, e));
      break;
    case "sourceFilesPaths":
      o(e, "array") ? r.sourceFilesPaths = e : o(e, "string") ? r.sourceFilesPaths = [e] : t.push(n(s, e));
      break;
    case "excludedPaths":
      o(e, "array") ? r.excludedPaths = e : o(e, "string") ? r.excludedPaths = [e] : t.push(n(s, e));
      break;
    case "assetsPath":
      o(e, "string") ? r.assetsPath = e : t.push(n(s, e));
      break;
    case "format":
      o(e, "json") ? r.format = e : t.push(n(s, e));
      break;
    case "filename":
      o(e, "string") ? r.filename = e : t.push(n(s, e));
      break;
    case "supportedLangs":
      o(e, "array") ? r.supportedLangs = e : o(e, "string") ? r.supportedLangs = [e] : t.push(n(s, e));
      break;
    case "keySeparator":
      o(e, "string") ? r.keySeparator = e : t.push(n(s, e));
      break;
    case "keyValueSeparator":
      o(e, "string") ? r.keyValueSeparator = e : t.push(n(s, e));
      break;
    case "error":
      t.push(e);
      break;
    default:
      t.push(`- unknown option: "${s}"`);
  }
}
r.supportedLangs || t.push(l("supportedLangs"));
if (t.length > 0) {
  console.log("\x1B[31m%s\x1B[0m", "Qwik Speak Extract errors:");
  for (const a of t)
    console.log(a);
  process.exit(1);
}
console.log("\x1B[36m%s\x1B[0m", "Qwik Speak Extract");
console.log("\x1B[32m%s\x1B[0m", "extracting translation...");
p(r);
